#include "FlashRead.hpp"
#include "../osHandles.h"
#include "../fat/ff.h"				// FAT File System Library
#include "../fat/diskio.h" 			// Disk IO Initialize SPI Mutex
#include "../drivers/sta013.h"
#include "../drivers/ssp_spi.h"
#include "utils/rprintf.h"
#include <stdlib.h>                 // atoi()
#include <stdio.h>                  // printf() or iprintf()
#include <string.h>                 // strtok()
#include "../drivers/pcm1774.h"   // PCM 1774 DAC
#include "../drivers/uart0.h"     // uart0GetChar()
#include "Chip_Select.h"

void FlashReadTask(void* p)
{
	OSHANDLES *osHandles = (OSHANDLES*) p;
	for (;;)
	{
		// TODO 4.  Perform xQueueReceive from "song name" queue
		int addr =0;
		int size = 12700;
		char FileNameSong[10];
		const unsigned int bytesToRead = 4096;
		//const unsigned int bytesToRead = 10;
		int count = 4;

		if (xQueueReceive(osHandles->queue.FlashSong,FileNameSong,1000))
		{

			// TODO 5.  Try to open the file, and read a block from file
		while(count--)
		{
			char buff[4096] = { 0 };
			if (xSemaphoreTake(osHandles->lock.SPI, 3000))
			{
				CS_Sel(sel_Flash);
				rxTxByteSSPSPI(0x0B);
				rxTxByteSSPSPI((addr >> 16)); //readwr((addr>>24));
				rxTxByteSSPSPI((addr >> 8));
				rxTxByteSSPSPI((addr >> 0)); //Dummy Byte
				int buf = rxTxByteSSPSPI(0x00); // Don't care...need for this??
				unsigned int i=0;
				while (i <= bytesToRead)
				{
					buff[i++] = rxTxByteSSPSPI(0x00);
					addr++;
				}
				CS_Sel(sel_Nothing);
				xSemaphoreGive(osHandles->lock.SPI);
			}
			else
				{
				rprintf("Flash can not take SPI Semaphore \n");
				}


			if (xSemaphoreTake(osHandles->lock.SPI, 3000))
						{
							SELECT_MP3_CS();
							unsigned int j = 0;
								while (j <= bytesToRead)
								{
									if (STA013_NEEDS_DATA())
									{
										//rprintf("%c", buff[j]);
										rxTxByteSSPSPI(buff[j++]);

									}
									else
									{
										vTaskDelay(2);
									}
								}
								//deassert
								DESELECT_MP3_CS();
								xSemaphoreGive(osHandles->lock.SPI);
							}
					else
						{
						rprintf("MP3 Decoder can not take SPI Semaphore \n");
						}
		}
		rprintf("Done Reading \n");
		}

	}
}
