#include "MotorControl.hpp"
#include "../drivers/pwm.h"
#include "../System/lpc214x.h"

void BackMotorForward(unsigned int frontSensorValue)
{
	/************Direction->Forward********/
	IOCLR0 = (1 << 8);
	/***********Activate PWM***************/


	if(frontSensorValue < 80) {
		PWMMR2 = 24000; //(Speed of Car is 50%)
	}
	else if(frontSensorValue < 250) {
		PWMMR2 = 32000; //(Speed of Car is 30%)
	}
	else {
		PWMMR2 = 16000; //(Speed of Car is 75%)
	}
	PWMLER = 0x04;
}

void BackMotorBackward()
{
	/************Direction->Forward********/
	IOSET0 = (1 << 8);
	/***********Activate PWM***************/
	PWMMR2 = 32000;
	PWMLER = 0x04;
	//	vTaskDelay(2);

}

void FrontMotorRight()
{
	/***********Activate PWM***************/
	PWMMR6 = 00000;
	PWMLER = 0x40;
	/************Turn Right*****************/
	IOCLR0 = (1 << 5);
	//vTaskDelay(2);
}

void FrontMotorLeft()
{
	/***********Activate PWM***************/
	PWMMR6 = 00000;
	PWMLER = 0x40;
	/************Turn Right*****************/
	IOSET0 = (1 << 5);
	//	vTaskDelay(2);
}

void FrontMotorCenter()
{
	/***********Activate PWM For Center Position***************/
	PWMMR6 = 48000;
	PWMLER = 0x40;
	//	vTaskDelay(2);
}
