/*
 * Read&Write.cpp
 *
 *  Created on: Mar 11, 2012
 *      Author: Saini
 */
#include "../Chip_Select.h"
#include "../drivers/ssp_spi.h"
#include "../utils/rprintf.h"     // r
#include "Read_Write.h"
#include "../drivers/sta013.h"
#include "../osHandles.h"

void WriteEnable()
{
	CS_Sel(sel_Flash);
	char opCodeToWriteEnable = 0x06;
	rxTxByteSSPSPI(opCodeToWriteEnable);
	CS_Sel(sel_Nothing);
}

void WriteDisable()
{
	CS_Sel(sel_Flash);
	char opCodeToWriteEnable = 0x04;
	rxTxByteSSPSPI(opCodeToWriteEnable);
	CS_Sel(sel_Nothing);
}

void DisableGlobalProtection()
{
	WriteEnable();
	CS_Sel(sel_Flash);
	char FirstopCodeToDisable = 0x01;
	char SecondopCodeToDisable = 0x00;
	rxTxByteSSPSPI(FirstopCodeToDisable);
	rxTxByteSSPSPI(SecondopCodeToDisable);
	CS_Sel(sel_Nothing);
}

void Erase(int addr1)
{
	CS_Sel(sel_Flash);
	char opCodeToErase = 0x20;
	rxTxByteSSPSPI(opCodeToErase);
	rxTxByteSSPSPI((addr1 >> 16)); //check for 0
	rxTxByteSSPSPI((addr1 >> 8));
	rxTxByteSSPSPI((addr1 >> 0));
	//if(EPE = 1)
	//rprintf("Eroor in Erasing");
	CS_Sel(sel_Nothing);
}

void Status()
{
	//char CheckStatus;
	CS_Sel(sel_Flash);
	char opCode4Status = 0x05;
	rxTxByteSSPSPI(opCode4Status);
	while(rxTxByteSSPSPI(0x00) & (1<<0))
	{

	}
		//return 0;
	CS_Sel(sel_Nothing);
}

void Read(int addr, int size)
{
	char buf;
	//char* buf1[size];
	CS_Sel(sel_Flash);
	rxTxByteSSPSPI(0x0B);
	rxTxByteSSPSPI((addr >> 16)); //readwr((addr>>24));
	rxTxByteSSPSPI((addr >> 8));
	rxTxByteSSPSPI((addr >> 0)); //Dummy Byte
	buf = rxTxByteSSPSPI(0x00); // Don't care...need for this??

	while (size--)
	{
		rprintf("%c", buf);
		buf = rxTxByteSSPSPI(0x00); // Send don't care to receive a byte
		//buf1 = &buf;
		//buf1++;
		//rprintf("%c", buf);
	}
	//rprintf("\n");
	CS_Sel(sel_Nothing);
	//return buf1;
}

//READ FROM FLASH AND FEED IN MP3 DECODER
void ReadFromFlashFeedMP3(int addr, int size)
{
	char buf;
	//char* buf1[size];
	CS_Sel(sel_Flash);
	rxTxByteSSPSPI(0x0B);
	rxTxByteSSPSPI((addr >> 16)); //readwr((addr>>24));
	rxTxByteSSPSPI((addr >> 8));
	rxTxByteSSPSPI((addr >> 0)); //Dummy Byte
	buf = rxTxByteSSPSPI(0x00); // Don't care...need for this??
	rprintf("Inside Read \n");
	SELECT_MP3_CS();
	rprintf("Inside MP3 Chip Select \n");
	while (size--)
	{
		//rprintf("%c", buf);
		rprintf("Inside While Loop \n");
		buf = rxTxByteSSPSPI(0x00); // Send don't care to receive a byte
		//buf1 = &buf;
		//buf1++;
		if (STA013_NEEDS_DATA())
			{
			rprintf("Inside MP3 Decoder \n");
			rxTxByteSSPSPI(buf);
			}
		else
			{
			vTaskDelay(3);
			}

	}
	//rprintf("\n");
	DESELECT_MP3_CS();
	CS_Sel(sel_Nothing);
	rprintf("Done Reading");
}

// Write For Page/Byte

void Write(char* buf, int addr, int size)
{
	CS_Sel(sel_Flash);
	//Opcode for Byte/Page
	rxTxByteSSPSPI(0x02);
	rxTxByteSSPSPI((addr >> 16));
	rxTxByteSSPSPI((addr >> 8));
	rxTxByteSSPSPI((addr >> 0)); //according to protocol
	int i = 0;
	while (size--)
	{
		rxTxByteSSPSPI(buf[i]); //check for 8 bits CPOL, CPHA
		i++;
	}
	CS_Sel(sel_Nothing);
}


// Write For Sequential
void WriteSequentialIntital(char buf,int addr)
{

	CS_Sel(sel_Flash);

	//OPcode for Sequential
	rxTxByteSSPSPI(0xAD);
	rxTxByteSSPSPI((addr >> 16));
	rxTxByteSSPSPI((addr >> 8));
	rxTxByteSSPSPI((addr >> 0)); //according to protocol
	rxTxByteSSPSPI(buf); //check for 8 bits CPOL, CPHA

	CS_Sel(sel_Nothing);
}

void WriteSequential(char buf)
	{
		CS_Sel(sel_Flash);

		//OPcode for Sequential
		rxTxByteSSPSPI(0xAD);
		rxTxByteSSPSPI(buf);

		CS_Sel(sel_Nothing);
	}

void DisableCS()
{
	CS_Sel(sel_Flash);
}
