	#include "pwm.h"
#include "../System/lpc214x.h"


/*NOTE:PWM Match register that determines the PWM rate
(PWM Match 0) must be set up prior to the PWM being
enabled.*/

void initialize_PWM_FrontBackWheel()
{
/****************Back Wheel Pin Initalization****************************/
	PINSEL0 &= ~(3 << 14);
	PINSEL0 |= (2 << 14);    // select PWM2 for P0.7 pin function

	PINSEL0 &= ~(3 << 16); // select GPIO for DIR at P0.8 pin function
	IODIR0 	|= (1 << 8);
/****************Front Wheel Pin Initalization****************************/
	PINSEL0 &= ~(3 << 18);
	PINSEL0 |= (2 << 18);    // Select PWM6 at P0.9 pin function

	PINSEL0 &= ~(3 << 10); // Select GPIO for DIR at P0.5 pin function
	IODIR0 	|= (1 << 5);
/*******************PWM Initalization************************************/
	PWMPR = 0; // PWM Prescale register....PWMTC increase on every PCLK.
	PWMMCR = 0x00000002; // PWM match control - reset PMWTC at Match 0
	PWMPCR = 0x4400; //New
	PWMMR0 = 48000; // PWM match register 0 - determines PWM frequency
	PWMMR2 = 48000; // PWM match register 2 to set the Duty Cycle
	PWMMR6 = 48000; // PWM match register 6 to set the Duty Cycle
	PWMLER = 0x44;
	PWMTCR = 0x02; //RESET PWMTC, (bit 1)
	PWMTCR = 0x09; // PWM timer control: counters enabled, PWM enabled
}
